"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessAnalyzeBundlePlugin = void 0;
const bundleVisualizer_1 = require("./bundleVisualizer");
class ServerlessAnalyzeBundlePlugin {
    constructor(serverless, options) {
        this.bundleVisualizer = bundleVisualizer_1.default.bind(this);
        this.options = options;
        this.serverless = serverless;
        this.commands = {
            package: {
                usage: 'Analyze the bundle of a lambda function',
                options: {
                    analyze: {
                        type: 'string',
                        usage: 'Specify the function you want to analyze (e.g. "--analyze \'helloWorld\'")',
                    },
                },
            },
        };
        this.hooks = {
            'before:package:initialize': () => {
                const { analyze } = this.options;
                if (analyze === undefined) {
                    return;
                }
                this.serverless.service.custom.esbuild.metafile = true;
            },
            'after:package:finalize': () => __awaiter(this, void 0, void 0, function* () {
                const { analyze } = this.options;
                if (analyze === undefined) {
                    return;
                }
                yield this.bundleVisualizer();
            }),
        };
    }
}
exports.ServerlessAnalyzeBundlePlugin = ServerlessAnalyzeBundlePlugin;
